init python:
  import wave
  import json
  
  def bin2int(s, w):
    v = 0
    lim = 1 << (w * 8)
    for i in range(w):
      v |= ord(s[i]) << (i * 8)
    if v > (lim / 2):
      v -= lim
    return v
  def convert_wav(path):
    w = wave.open(renpy.file(path))
    
    (nchannels, sampwidth, framerate, nframes, comptype, compname) = w.getparams()
    
    #Read half, read the target frame, read half. Repeat until the file has been exhausted
    fps = 20
    
    #Skip this many samples for each sample read. This makes things more efficient
    sk = 50
    
    dat = []
    readbytes = 0
    reading = True
    while reading:
      mi = 0
      ma = 0
      for i in range(framerate / fps / (sk+1)):
        w.readframes(sk)
        fr = w.readframes(1)
        if len(fr) < nchannels*sampwidth:
          reading = False
          break
        v = 0
        for c in range(nchannels):
          v += bin2int(fr[c * sampwidth:(c+1)*sampwidth], sampwidth)
        v /= nchannels
        ma = max(ma, v)
        mi = min(mi, v)
      dat.append(max(abs(ma), abs(mi)))

    w.close()
    
    fp = open(config.gamedir + "/" + path.replace('.wav', '.lip'), 'wb')
    json.dump(dat, fp)
    fp.close()
    #return dat
  
  def do_conversion():
    #out = []
    for f in renpy.list_files():
      if f.endswith('.wav'):
        convert_wav(f)
    #return out

screen waveform:
  add Solid('#fff')
  grid len(wav) 1:
    xfill True yfill True
    for i in wav:
      $v = 300 + i/110
      add Solid('#f00', ymaximum=v)

label cv:
  $out = do_conversion()
  "Converted voice files"
  return
