﻿init python:
    import json
    # This is set to the name of the character that is speaking, or
    # None if no character is currently speaking.
    speaking = None
    
    thresh_a = 1000
    thresh_b = 10000
    
    speaking_filename = None
    speaking_lipseq = None
    st_reset = 0
    st_reset_on = False
    def st_reset_call():
      renpy.store.st_reset_on = True
    config.interact_callbacks.append(st_reset_call)
    # This returns speaking if the character is speaking, and done if the
    # character is not.
    def while_speaking(name, speak_d, done_d, st, at):
        global st_reset_on, st_reset, speaking_filename, speaking_lipseq
        if st_reset_on:
          st_reset_on = False
          st_reset = st
        st = st - st_reset
        if renpy.music.is_playing('voice') and speaking == name:
            if renpy.music.get_playing(channel='voice') != speaking_filename:
              speaking_filename = renpy.music.get_playing(channel='voice')
              fp = renpy.file(speaking_filename.replace('.ogg', '.lip'))
              speaking_lipseq = json.load(fp)
              fp.close()
            fpos = int(st / (1.0 / 20))
            if fpos < len(speaking_lipseq):
              v = speaking_lipseq[fpos]
            else:
              v = speaking_lipseq[-1]
            if v > renpy.store.thresh_b:
              return LiveComposite((260, 578), (0, 0), speak_d[2], (0, 0), Text(str(v), color='#FFF')), 0
              #return speak_d[2], 0
            if v > renpy.store.thresh_a:
              return LiveComposite((260, 578), (0, 0), speak_d[1], (0, 0), Text(str(v), color='#FFF')), 0
              #return speak_d[1], 0
            return LiveComposite((260, 578), (0, 0), speak_d[0], (0, 0), Text(str(v), color='#FFF')), 0
            #return speak_d[0], 0
            #return Text("%r %r" % (st, at), color='#900'), 0
            #return speak_d, .1
        else:
            return done_d, None
 
    # Curried form of the above.
    curried_while_speaking = renpy.curry(while_speaking)
 
    # Displays speaking when the named character is speaking, and done otherwise.
    def WhileSpeaking(name, speaking_d, done_d=Null()):
        return DynamicDisplayable(curried_while_speaking(name, speaking_d, done_d))
 
    # This callback maintains the speaking variable.
    def speaker_callback(name, event, **kwargs):
        global speaking
        speaking = name
 
    # Curried form of the same.
    speaker = renpy.curry(speaker_callback)

# Create such a character.
define girl = Character("Girl", callback=speaker("girl"))

# Composite things together to make a character with blinking eyes and
# lip-flap.
image girl normal = LiveComposite(
    (260, 578),
    (0, 0), "base.png",
    (0, 0), WhileSpeaking("girl", ("mouth_closed.png", "mouth_speak1.png", "mouth_speak2.png"), "mouth_closed.png"),
    )

image girl mouth normal:
    "mouth_speak1.png"
    .2
    "mouth_speak2.png"
    .2
    repeat

screen threshold_change:
  vbox:
    hbox:
      textbutton "-" action SetVariable("thresh_a", thresh_a - 100)
      label "[thresh_a]"
      textbutton "+" action SetVariable("thresh_a", thresh_a + 100)
    hbox:
      textbutton "-" action SetVariable("thresh_b", thresh_b - 100)
      label "[thresh_b]"
      textbutton "+" action SetVariable("thresh_b", thresh_b + 100)
# The game starts here.
label start:
    show screen threshold_change
    show girl normal
label loop:
    voice "v_01.ogg"
    girl "Once you add a story, pictures, and music, you can release it to the world!"
    jump loop
